#!/bin/sh
#
# Copyright 2002-2005 G.U.F.I. All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#  1.Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
#  2.Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation 
#    and/or other materials provided with the distribution. 
#
# THIS SOFTWARE IS PROVIDED BY G.U.F.I. ``AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
# EVENT SHALL THE FREEBSD PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
# EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# The views and conclusions contained in the software and documentation are
# those of the authors and should not be interpreted as representing official
# policies, either expressed or implied, of the G.U.F.I.
#
# $Id: 0.rmdir.sh,v 1.15 2005/06/16 01:51:55 saturnero Exp $
# vim: set ts=4:
#
# (optional) Cleans FREESBIEBASEDIR and FREESBIEISODIR. 
# Useful when this directory becomes useless.

. ./config.sh
. ./.common.sh

mkdir -p $FREESBIEBASEDIR || print_error
if [ -r $FREESBIEBASEDIR ]; then
	chflags -R noschg $FREESBIEBASEDIR || print_error
	rm -rf $FREESBIEBASEDIR/* || print_error
fi
mkdir -p $FREESBIEISODIR || print_error
if [ -r $FREESBIEISODIR ]; then
	chflags -R noschg $FREESBIEISODIR || print_error
	rm -rf $FREESBIEISODIR/* || print_error
fi

cd $LOCALDIR
[ ! -z "${BATCH_MODE:-}" ] && sh 1.mkdir.sh
return 0
