#!/bin/sh
#
# Copyright 2002-2005 G.U.F.I. All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#  1.Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
#  2.Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation 
#    and/or other materials provided with the distribution. 
#
# THIS SOFTWARE IS PROVIDED BY G.U.F.I. ``AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
# EVENT SHALL THE FREEBSD PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
# EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# The views and conclusions contained in the software and documentation are
# those of the authors and should not be interpreted as representing official
# policies, either expressed or implied, of the G.U.F.I.
#
# $Id: 3.installworld.sh,v 1.29 2005/06/16 01:51:55 saturnero Exp $
# vim: set ts=4:
#
# (obligatory) Populates $FREESBIEBASEDIR and install world in it

set -e -u

. ./config.sh
. ./.common.sh

if [ "x$MINIMAL" = "xYES" ]; then
	export __MAKE_CONF=$LOCALDIR/files/make.conf.minimal # Redefine make.conf path
else
	export __MAKE_CONF=$LOCALDIR/files/make.conf # Redefine make.conf path
fi

echo "Copying /etc files..."
cd ${SRCDIR:-/usr/src}/etc || print_error

#Create a temporary log file
TEMP_FILE=`mktemp -q /tmp/freesbieXXXXXX`

#Trap ctrl+c and delete TEMP_FILE
trap "rm -f $TEMP_FILE && exit 1" INT

(script -aq $TEMP_FILE make distrib-dirs DESTDIR=$FREESBIEBASEDIR $MAKEOPT || print_error) | grep '^>>>'
(script -aq $TEMP_FILE make distribution DESTDIR=$FREESBIEBASEDIR $MAKEOPT || print_error) | grep '^>>>'

echo "Installing world..."
echo "To see the complete output of this script is doing, type:"
echo "tail -f $TEMP_FILE"

cd ${SRCDIR:-/usr/src} || print_error
(script -aq $TEMP_FILE make installworld DESTDIR=$FREESBIEBASEDIR $MAKEOPT || print_error) | grep '^>>>'
rm -f $TEMP_FILE

echo "[DONE]"

cd $LOCALDIR
[ ! -z "${BATCH_MODE:-}" ] && sh 4.kernel.sh
return 0