#!/bin/sh
#
# Copyright 2002-2005 G.U.F.I. All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#  1.Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
#  2.Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation 
#    and/or other materials provided with the distribution. 
#
# THIS SOFTWARE IS PROVIDED BY G.U.F.I. ``AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
# EVENT SHALL THE FREEBSD PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
# EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# The views and conclusions contained in the software and documentation are
# those of the authors and should not be interpreted as representing official
# policies, either expressed or implied, of the G.U.F.I.
#
# $Id: 81.mkiso.sh,v 1.14 2005/06/30 14:48:32 saturnero Exp $	
# vim: set ts=4:
# 
# (obligatory if you didn't define MINIMAL)
# Creates the ISO for a complete (non MINIMAL) FreeSBIE LiveCD
# The ISO image can be burned with any CD burning sotware

set -u

. ./config.sh

if [ ! -x /usr/local/bin/mkisofs ]; then
	echo "Missing mkisofs. Please install sysutils/cdrtools from ports collection"
	exit 1
fi

echo "Saving mtree structure..."
cd $LOCALDIR
mtree -Pcp $FREESBIEISODIR | bzip2 -9 > FreeSBIE.root.dist.bz2
mv FreeSBIE.root.dist.bz2 $FREESBIEISODIR/dist/

cd $FREESBIEISODIR

if [ "$ARCH" = "powerpc" ]; then
	cp ${SRCDIR:-/usr/src}/release/powerpc/boot.tbxi boot
	/usr/local/bin/mkisofs -hfs-bless boot -map ${SRCDIR:-/usr/src}/release/powerpc/hfs.map -r -hfs -part -no-desktop -hfs-volid FreeSBIE -ldots -J -o $PATHISO .
else
	/usr/local/bin/mkisofs -b boot/cdboot -no-emul-boot -JR -ldots -V FreeSBIE -p FreeSBIE -o $PATHISO .
fi
echo "------------------------------------------------------------"
echo "Your FreeSBIE iso is ready to fly and is located in"
echo "$PATHISO."
echo "If you have got an IDE/ATAPI cd burner you"
echo "can use burncd(1) in order to burn it, e.g. "
echo "burncd -f /dev/acd0 -s 12 data $PATHISO fixate ."
echo "------------------------------------------------------------"
