#!/bin/sh
# 
# Copyright 2002-2005 G.U.F.I. All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#  1.Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
#  2.Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation 
#    and/or other materials provided with the distribution. 
#
# THIS SOFTWARE IS PROVIDED BY G.U.F.I. ``AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
# EVENT SHALL THE FREEBSD PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
# EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# The views and conclusions contained in the software and documentation are
# those of the authors and should not be interpreted as representing official
# policies, either expressed or implied, of the G.U.F.I.
#
# $Id: xfree_layout.sh,v 1.3 2005/04/26 17:22:46 rionda Exp $
#

LAYOUT_DIR="/usr/X11R6/lib/X11/xkb/rules/"
if [ -e $LAYOUT_DIR/xorg.lst ]; then
	LAYOUT_FILE="xorg.lst"
else
	LAYOUT_FILE="xfree86.lst"
fi
DIALOG_FILE="/root/layout_dialog.sh"
XF86_CFG="/etc/X11/XF86Config"
XF86_TMP_CFG="/tmp/XF86Config"

if [ -e ${LAYOUT_DIR}${LAYOUT_FILE} ]; then
    cp ${LAYOUT_DIR}${LAYOUT_FILE} .
else
    echo "Problems with XFree86 sources"
    exit -1
fi

rm -f $DIALOG_FILE

echo "dialog --title \"FreeSBIE XFree86 Layout\" \
    --menu \"Choose your preferred keyboard layout\" 22 50 15 \\" >> ${DIALOG_FILE}

awk '{
if ($1 == "!") {
    if ($2 == "layout") {
        getline;
        while ($0 != "!" && $0 != "") {
            print $1 "\t\"" $2 "\" \\";
            getline;
        }
    }
}
}' $LAYOUT_FILE >> ${DIALOG_FILE}
rm $LAYOUT_FILE
echo "2> /root/.choose" >> ${DIALOG_FILE}
sh ${DIALOG_FILE}
rm -f ${DIALOG_FILE}
LAYOUT=`cat /root/.choose`
echo "Detected $LAYOUT"
rm -f /root/.choose
cp ${XF86_CFG} ${XF86_TMP_CFG}
sed "s/\"us\"/\"${LAYOUT}\"/" < ${XF86_TMP_CFG} > ${XF86_CFG}
rm -f ${XF86_TMP_CFG}
