#!/bin/sh
#
# Copyright 2002-2005 G.U.F.I. All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#  1.Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
#  2.Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation 
#    and/or other materials provided with the distribution. 
#
# THIS SOFTWARE IS PROVIDED BY G.U.F.I. ``AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
# EVENT SHALL THE FREEBSD PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
# EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# The views and conclusions contained in the software and documentation are
# those of the authors and should not be interpreted as representing official
# policies, either expressed or implied, of the G.U.F.I.
#
#$Id: mount_usb.sh,v 1.3 2005/04/26 17:22:46 rionda Exp $

wait_partitions() {
  PART_DISC=`ls /dev/${i}*`
  [ ! "${PART_DISC}" ] && wait_partitions
}

find_free_dir() {
  ID=`/sbin/mount | grep "/mnt/dos.*" | tail -1 | cut -d\  -f 3 | cut -d. -f 2`
  [ ! "${ID}" ] && ID=0
  NEWID=`expr ${ID} + 1`
  FREEDIR=`echo "/mnt/dos.${NEWID}`
}

/sbin/camcontrol rescan all > /dev/null
DEVLIST=`/sbin/camcontrol devlist | cut -d\( -f 2 | cut -d\) -f 1 | grep da \
	| sed "s/.*da/da/" | sed "s/,.*//"`
[ ! "${DEVLIST}" ] && exit 0

for i in ${DEVLIST}
do
  wait_partitions
  for j in ${PART_DISC} 
  do
    find_free_dir
    mount -t msdos $j ${FREEDIR}
  done
done
